﻿namespace ArraysWithMoreDimensions
{
    public class Program
    {
        public static void Main(string[] args)
        {
            int[,] predefinedMatrix = new int[3,10]
            {
                { 10, 11, 12, 13, 14, 15, 16, 17, 18, 19},
                { 20, 21, 22, 23, 24, 25, 26, 27, 28, 29},
                { 30, 31, 32, 33, 34, 35, 36, 37, 38, 39}
            };

            int rows = predefinedMatrix.GetLength(0);
            int columns = predefinedMatrix.GetLength(1);

            for (int i = 0; i < rows; i++)
            {
                Console.WriteLine(predefinedMatrix[i, 2]);
            }

            for (int i = 0; i < columns; i++)
            {
                Console.Write(predefinedMatrix[1, i] + ", ");
            }
            Console.WriteLine("\n\n");

            for (int row = 0; row < rows; row++)
            {
                int total = 0;

                for (int col = 0; col < columns; col++)
                {
                    int currentNumber = predefinedMatrix[row, col];
                    Console.Write(currentNumber + ", ");
                    total += currentNumber;
                }
                double average = (double)total / columns;
                Console.WriteLine($"Average: {average}");
            }
            Console.WriteLine("\n\n");

            //////////////////////////////////////////
            //////////////////////////////////////////
            //////////////////////////////////////////

            int[][] jaggedArray = {
                new int[] { 2, 8, 4, 6},
                new int[] { 3, 6},
                new int[] { 10, 20, 40}
            };

            int jaRows = jaggedArray.Length;
            for (int row = 0; row < jaRows; row++)
            {
                int[] innerArray = jaggedArray[row];
                int jaCols = innerArray.Length;

                for (int col = 0; col < jaCols; col++)
                {
                    //int current = innerArray[col];
                    int current = jaggedArray[row][col];
                    Console.Write($"{current}, ");
                }
                Console.WriteLine();
            }

            Console.WriteLine("\n\n");

            List<List<int>> jaggedLists = new List<List<int>>();
            jaggedLists.Add(new List<int>());
            jaggedLists[0].Add(25);
            jaggedLists[0].Add(35);
            jaggedLists.Add(new List<int>());
            jaggedLists[1].Add(64);
            jaggedLists.Add(new List<int>());
            jaggedLists[2].Add(33);
            jaggedLists[2].Add(73);
            jaggedLists[2].Add(93);

            foreach (var row in jaggedLists)
            {
                foreach (var col in row)
                {
                    Console.Write($"{col}, ");
                }
                Console.WriteLine();
            }

            Console.WriteLine("\n\n");

            List<List<int>> jaggedLists2 = new List<List<int>>() {
                new List<int>() { 2, 8, 4, 6},
                new List<int>() { 3, 6},
                new List<int>() { 10, 20, 40}
            };

            foreach (var row in jaggedLists2)
            {
                foreach (var col in row)
                {
                    Console.Write($"{col}, ");
                }
                Console.WriteLine();
            }
        }
    }
}